//-----------------------------------------------------------------------------
//
// Title       : phase1a_tf
// Design      : lab4
// Author      : Steven
// Company     : University of Washington CSE
//
//-----------------------------------------------------------------------------
//
// File        : phase1a_tf.v
// Generated   : Wed Nov  8 19:59:01 2006
// From        : 
// By          : tb_verilog.pl ver. ver 1.2s
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`timescale 1ps / 1ps
module phase1a_tf;
//Parameters declaration: 

//Internal signals declarations:
reg [25:16]ID_Inst;
reg [4:0]WB_WriteReg;
reg WB_RegWrite;
reg [4:0]MEM_WriteReg;
reg MEM_RegWrite;
wire [1:0]Fwd_EX_RT_actual;
reg [1:0]Fwd_EX_RT;
wire [1:0]Fwd_EX_RS_actual;
reg [1:0]Fwd_EX_RS;
reg EX_JAL;
reg [25:16]EX_Inst;
wire Fwd_ID_RT_actual;
reg Fwd_ID_RT;
wire Fwd_ID_RS_actual;
reg Fwd_ID_RS;
reg ID_Branch;
reg ID_JR;
//LOG file declaration.
integer report_file;

//Wait time declaration used in ports monitoring.
//One parameter is declared for every port.
parameter Default_wait_time = 10;
parameter Fwd_EX_RT_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_EX_RT
parameter Fwd_EX_RS_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_EX_RS
parameter Fwd_ID_RT_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_ID_RT
parameter Fwd_ID_RS_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_ID_RS

//Simulation time
parameter SimulationTime = 64'd1804000 + Default_wait_time + 1;

//Errors counter
integer errors_counter;

//Block of Comparison functions declarations. A separate function for each output port is defined.
//Comparison function for port "Fwd_EX_RT"
function compare_Fwd_EX_RT;
input [1:0] UUT_output;
input [1:0] PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_EX_RT = 1'b1;
		else compare_Fwd_EX_RT = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_EX_RS"
function compare_Fwd_EX_RS;
input [1:0] UUT_output;
input [1:0] PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_EX_RS = 1'b1;
		else compare_Fwd_EX_RS = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_ID_RT"
function compare_Fwd_ID_RT;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_ID_RT = 1'b1;
		else compare_Fwd_ID_RT = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_ID_RS"
function compare_Fwd_ID_RS;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_ID_RS = 1'b1;
		else compare_Fwd_ID_RS = 1'b0;
	end
endfunction

// Unit Under Test port map
	ForwardingUnit UUT (
		.ID_Inst(ID_Inst),
		.WB_WriteReg(WB_WriteReg),
		.WB_RegWrite(WB_RegWrite),
		.MEM_WriteReg(MEM_WriteReg),
		.MEM_RegWrite(MEM_RegWrite),
		.Fwd_EX_RT(Fwd_EX_RT_actual),
		.Fwd_EX_RS(Fwd_EX_RS_actual),
		.EX_JAL(EX_JAL),
		.EX_Inst(EX_Inst),
		.Fwd_ID_RT(Fwd_ID_RT_actual),
		.Fwd_ID_RS(Fwd_ID_RS_actual),
		.ID_Branch(ID_Branch),
		.ID_JR(ID_JR));

initial
	begin
		report_file=$fopen("$DSN\\src\\Tests\\phase1a_report.log");
		errors_counter = 0;
		#SimulationTime;
		if (errors_counter)
		begin
			$display("Errors were encountered, differences are listed in phase1a_report.log");
			$fdisplay(report_file,"Some vectors failed.");
		end
		else
		begin
			$display("All vectors passed.");
			$fdisplay(report_file,"All vectors passed.");
		end
		$fclose(report_file);
		$finish;
	end

initial
begin : STIMUL // begin of stimulus process
	#0
	ID_Inst = 10'bXXXXXXXXXX;
	WB_WriteReg = 5'bXXXXX;
	MEM_WriteReg = 5'bXXXXX;
	WB_RegWrite = 1'bx;
	Fwd_EX_RS = 2'bXX;
	Fwd_EX_RT = 2'bXX;
	MEM_RegWrite = 1'bx;
	ID_JR = 1'bx;
	ID_Branch = 1'bx;
	EX_Inst = 10'bXXXXXXXXXX;
	EX_JAL = 1'bx;
	Fwd_ID_RS = 1'bx;
	Fwd_ID_RT = 1'bx;
    #165000; //0
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_RegWrite = 1'b0;
	ID_JR = 1'b0;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000000;
	EX_JAL = 1'b0;
	Fwd_ID_RS = 1'b0;
	Fwd_ID_RT = 1'b0;
    #20000; //165000
	ID_Inst = 10'b0000000001;
    #20000; //185000
	ID_Inst = 10'b0000101001;
	MEM_RegWrite = 1'b1;
	EX_Inst = 10'b0000000001;
    #20000; //205000
	ID_Inst = 10'b0000000001;
	MEM_WriteReg = 5'b00001;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0000101001;
    #20000; //225000
	ID_Inst = 10'b0000101010;
	WB_WriteReg = 5'b00001;
	MEM_WriteReg = 5'b01001;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	EX_Inst = 10'b0000000001;
    #20000; //245000
	ID_Inst = 10'b0000011101;
	WB_WriteReg = 5'b01001;
	MEM_WriteReg = 5'b00001;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b0000101010;
    #20000; //265000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00001;
	MEM_WriteReg = 5'b01010;
	Fwd_EX_RS = 2'b00;
	EX_Inst = 10'b0000011101;
    #20000; //285000
	ID_Inst = 10'b0001000000;
	WB_WriteReg = 5'b01010;
	MEM_WriteReg = 5'b11101;
	EX_Inst = 10'b0000000000;
    #20000; //305000
	WB_WriteReg = 5'b11101;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0001000000;
    #20000; //325000
	ID_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b11;
    #20000; //345000
	ID_Inst = 10'b0001000011;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b00;
	EX_Inst = 10'b0000000010;
    #20000; //365000
	ID_Inst = 10'b0001000100;
	WB_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0001000011;
    #20000; //385000
	ID_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b11;
	EX_Inst = 10'b0001000100;
    #20000; //405000
	ID_Inst = 10'b0001011101;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b00;
	EX_Inst = 10'b0000000010;
    #20000; //425000
	WB_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0001011101;
    #20000; //445000
	ID_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00010;
    #20000; //465000
	ID_Inst = 10'b0001000010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	EX_Inst = 10'b0000000010;
    #20000; //485000
	ID_Inst = 10'b0001000011;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b0001000010;
    #20000; //505000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b0001000011;
    #20000; //525000
	ID_Inst = 10'b0000000101;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	EX_Inst = 10'b0000000000;
    #20000; //545000
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b0000000101;
    #20000; //565000
	WB_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00110;
	Fwd_EX_RT = 2'b11;
    #20000; //585000
	ID_Inst = 10'b1110100101;
	WB_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00111;
	Fwd_EX_RT = 2'b00;
    #20000; //605000
	WB_WriteReg = 5'b00111;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b1110100101;
    #20000; //625000
	ID_Inst = 10'b0000000101;
	WB_WriteReg = 5'b00101;
    #20000; //645000
	ID_Inst = 10'b1110100101;
	MEM_WriteReg = 5'b00110;
	Fwd_EX_RT = 2'b11;
	EX_Inst = 10'b0000000101;
    #20000; //665000
	WB_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b1110100101;
    #20000; //685000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00101;
    #20000; //705000
	ID_Inst = 10'b0001011101;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1110111101;
    #20000; //725000
	ID_Inst = 10'b0001000011;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0001011101;
    #20000; //745000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b11;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b0001000011;
    #20000; //765000
	ID_Inst = 10'b1110100010;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1110111101;
    #20000; //785000
	ID_Inst = 10'b0001100010;
	WB_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b1110100010;
    #20000; //805000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b11;
	EX_Inst = 10'b0001100010;
    #20000; //825000
	ID_Inst = 10'b0001000010;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1110111101;
    #20000; //845000
	WB_WriteReg = 5'b00100;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b0001000010;
    #20000; //865000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00010;
    #20000; //885000
	ID_Inst = 10'b1111111101;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
	EX_Inst = 10'b0000000000;
	EX_JAL = 1'b1;
    #20000; //905000
	ID_Inst = 10'b0010111111;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b11111;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1111111101;
	EX_JAL = 1'b0;
    #20000; //925000
	ID_Inst = 10'b1111100000;
	WB_WriteReg = 5'b11111;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b11;
	ID_JR = 1'b1;
	EX_Inst = 10'b0010111111;
    #20000; //945000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00110;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	ID_JR = 1'b0;
	EX_Inst = 10'b1111100000;
    #20000; //965000
	ID_Inst = 10'b0100100000;
	WB_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	ID_JR = 1'b1;
	EX_Inst = 10'b0000000000;
    #20000; //985000
	ID_Inst = 10'b1111111101;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
	MEM_RegWrite = 1'b1;
	ID_JR = 1'b0;
	EX_Inst = 10'b0100100000;
	EX_JAL = 1'b1;
    #20000; //1005000
	ID_Inst = 10'b0010111111;
	MEM_WriteReg = 5'b11111;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1111111101;
	EX_JAL = 1'b0;
    #20000; //1025000
	ID_Inst = 10'b1111100000;
	WB_WriteReg = 5'b11111;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b11;
	ID_JR = 1'b1;
	EX_Inst = 10'b0010111111;
    #20000; //1045000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00110;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	ID_JR = 1'b0;
	EX_Inst = 10'b1111100000;
    #20000; //1065000
	ID_Inst = 10'b0101000000;
	WB_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	ID_JR = 1'b1;
	EX_Inst = 10'b0000000000;
    #20000; //1085000
	ID_Inst = 10'b1111011101;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
	MEM_RegWrite = 1'b1;
	ID_JR = 1'b0;
	EX_Inst = 10'b0101000000;
	EX_JAL = 1'b1;
    #20000; //1105000
	ID_Inst = 10'b0010111110;
	MEM_WriteReg = 5'b11110;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	EX_Inst = 10'b1111011101;
	EX_JAL = 1'b0;
    #20000; //1125000
	ID_Inst = 10'b1111000000;
	WB_WriteReg = 5'b11110;
	MEM_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b11;
	ID_JR = 1'b1;
	EX_Inst = 10'b0010111110;
    #20000; //1145000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00101;
	MEM_WriteReg = 5'b00110;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	ID_JR = 1'b0;
	EX_Inst = 10'b1111000000;
    #20000; //1165000
	WB_WriteReg = 5'b00110;
	MEM_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	EX_Inst = 10'b0000000000;
    #20000; //1185000
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1205000
	ID_Inst = 10'b1110111101;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
    #20000; //1225000
	ID_Inst = 10'b0000011101;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	EX_Inst = 10'b1110111101;
    #20000; //1245000
	ID_Inst = 10'b1110111101;
	WB_RegWrite = 1'b1;
	EX_Inst = 10'b0000011101;
    #20000; //1265000
	ID_Inst = 10'b0000000000;
	MEM_WriteReg = 5'b00010;
	EX_Inst = 10'b1110111101;
    #20000; //1285000
	ID_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
	EX_Inst = 10'b0000000000;
    #20000; //1305000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00000;
	EX_Inst = 10'b0000011101;
    #20000; //1325000
	ID_Inst = 10'b1110100000;
	MEM_WriteReg = 5'b00010;
	EX_Inst = 10'b1110111101;
    #20000; //1345000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
	EX_Inst = 10'b1110100000;
    #20000; //1365000
	ID_Inst = 10'b0000001011;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
	EX_Inst = 10'b1110111101;
    #20000; //1385000
	ID_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
	EX_Inst = 10'b0000001011;
    #20000; //1405000
	ID_Inst = 10'b0101100011;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b01011;
	EX_Inst = 10'b0000011101;
    #20000; //1425000
	ID_Inst = 10'b0001100000;
	WB_WriteReg = 5'b01011;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	EX_Inst = 10'b0101100011;
    #20000; //1445000
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	MEM_RegWrite = 1'b0;
	EX_Inst = 10'b0001100000;
    #20000; //1465000
	ID_Inst = 10'b0101100011;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1485000
	ID_Inst = 10'b0000000011;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b1;
	EX_Inst = 10'b0101100011;
    #20000; //1505000
	MEM_WriteReg = 5'b00011;
	MEM_RegWrite = 1'b0;
	EX_Inst = 10'b0000000011;
    #20000; //1525000
	ID_Inst = 10'b0000001011;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00100;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1545000
	ID_Inst = 10'b0110000010;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b1;
	EX_Inst = 10'b0000001011;
    #20000; //1565000
	ID_Inst = 10'b0110000000;
	MEM_WriteReg = 5'b01100;
	Fwd_EX_RS = 2'b10;
	EX_Inst = 10'b0110000010;
    #20000; //1585000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b01100;
	MEM_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	MEM_RegWrite = 1'b0;
	EX_Inst = 10'b0110000000;
    #20000; //1605000
	ID_Inst = 10'b0101100010;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
	MEM_RegWrite = 1'b1;
	EX_Inst = 10'b1110111101;
    #20000; //1625000
	ID_Inst = 10'b0001000000;
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b00010;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b10;
	EX_Inst = 10'b0101100010;
    #20000; //1645000
	ID_Inst = 10'b0101101011;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	Fwd_EX_RT = 2'b00;
	MEM_RegWrite = 1'b0;
	EX_Inst = 10'b0001000000;
    #20000; //1665000
	MEM_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
	MEM_RegWrite = 1'b1;
	EX_Inst = 10'b0101101011;
    #20000; //1685000
	WB_WriteReg = 5'b00011;
	MEM_WriteReg = 5'b01011;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
    #20000; //1705000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b01011;
	WB_RegWrite = 1'b0;
    #20000; //1725000
	MEM_WriteReg = 5'b01100;
	MEM_RegWrite = 1'b1;
	EX_Inst = 10'b0000000000;
    #20000; //1745000
	WB_WriteReg = 5'b01100;
	MEM_WriteReg = 5'b00000;
	WB_RegWrite = 1'b1;
    #20000; //1765000
	WB_WriteReg = 5'b00000;
    #19000; //1785000
end // end of stimulus process
	



//Set of always bloks for ports monitoring.
//One block per output port.
//Always block for monitoring port "Fwd_EX_RT";
always @(Fwd_EX_RT or Fwd_EX_RT_actual)
	begin
		#Fwd_EX_RT_WaitTime
		if (compare_Fwd_EX_RT(Fwd_EX_RT,Fwd_EX_RT_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Fwd_EX_RT: Expected value is %b, Actual value is %b",Fwd_EX_RT,Fwd_EX_RT_actual);
			$display($realtime,,"ps; Error on port Fwd_EX_RT: Expected value is %b, Actual value is %b",Fwd_EX_RT,Fwd_EX_RT_actual);
		end
	end
//Always block for monitoring port "Fwd_EX_RS";
always @(Fwd_EX_RS or Fwd_EX_RS_actual)
	begin
		#Fwd_EX_RS_WaitTime
		if (compare_Fwd_EX_RS(Fwd_EX_RS,Fwd_EX_RS_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Fwd_EX_RS: Expected value is %b, Actual value is %b",Fwd_EX_RS,Fwd_EX_RS_actual);
			$display($realtime,,"ps; Error on port Fwd_EX_RS: Expected value is %b, Actual value is %b",Fwd_EX_RS,Fwd_EX_RS_actual);
		end
	end
//Always block for monitoring port "Fwd_ID_RT";
always @(Fwd_ID_RT or Fwd_ID_RT_actual)
	begin
		#Fwd_ID_RT_WaitTime
		if (compare_Fwd_ID_RT(Fwd_ID_RT,Fwd_ID_RT_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Fwd_ID_RT: Expected value is %b, Actual value is %b",Fwd_ID_RT,Fwd_ID_RT_actual);
			$display($realtime,,"ps; Error on port Fwd_ID_RT: Expected value is %b, Actual value is %b",Fwd_ID_RT,Fwd_ID_RT_actual);
		end
	end
//Always block for monitoring port "Fwd_ID_RS";
always @(Fwd_ID_RS or Fwd_ID_RS_actual)
	begin
		#Fwd_ID_RS_WaitTime
		if (compare_Fwd_ID_RS(Fwd_ID_RS,Fwd_ID_RS_actual))
		begin
			errors_counter = errors_counter + 1;
			$fdisplay(report_file,$realtime,,"ps; Port Fwd_ID_RS: Expected value is %b, Actual value is %b",Fwd_ID_RS,Fwd_ID_RS_actual);
			$display($realtime,,"ps; Error on port Fwd_ID_RS: Expected value is %b, Actual value is %b",Fwd_ID_RS,Fwd_ID_RS_actual);
		end
	end

endmodule
