//-----------------------------------------------------------------------------
//
// Title       : phase1b_tf
// Design      : lab4
// Author      : Steven
// Company     : University of Washington CSE
//
//-----------------------------------------------------------------------------
//
// File        : phase1b_tf.v
// Generated   : Wed Nov  8 20:24:17 2006
// From        : 
// By          : tb_verilog.pl ver. ver 1.2s
//
//-----------------------------------------------------------------------------
//
// Description : 
//
//-----------------------------------------------------------------------------

`timescale 1ps / 1ps
module phase1b_tf;
//Parameters declaration: 

//Internal signals declarations:
reg [25:16]ID_Inst;
reg ID_Branch;
reg ID_JR;
reg [25:16]EX_Inst;
reg EX_JAL;
reg [4:0]WB_WriteReg;
reg WB_RegWrite;
reg [4:0]MEM_WriteReg;
reg MEM_RegWrite;
wire Fwd_ID_RT_actual;
reg Fwd_ID_RT;
wire Fwd_ID_RS_actual;
reg Fwd_ID_RS;
wire [1:0]Fwd_EX_RT_actual;
reg [1:0]Fwd_EX_RT;
wire [1:0]Fwd_EX_RS_actual;
reg [1:0]Fwd_EX_RS;
//LOG file declaration.
integer report_file;

//Wait time declaration used in ports monitoring.
//One parameter is declared for every port.
parameter Default_wait_time = 10;
parameter Fwd_ID_RT_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_ID_RT
parameter Fwd_ID_RS_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_ID_RS
parameter Fwd_EX_RT_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_EX_RT
parameter Fwd_EX_RS_WaitTime = Default_wait_time;//WaitTime Parameter for port Fwd_EX_RS

//Simulation time
parameter SimulationTime = 64'd3104000 + Default_wait_time + 1;

//Errors counter
integer errors_counter;
parameter MAX_ERRORS=20;

//Block of Comparison functions declarations. A separate function for each output port is defined.
//Comparison function for port "Fwd_ID_RT"
function compare_Fwd_ID_RT;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_ID_RT = 1'b1;
		else compare_Fwd_ID_RT = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_ID_RS"
function compare_Fwd_ID_RS;
input  UUT_output;
input  PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_ID_RS = 1'b1;
		else compare_Fwd_ID_RS = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_EX_RT"
function compare_Fwd_EX_RT;
input [1:0] UUT_output;
input [1:0] PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_EX_RT = 1'b1;
		else compare_Fwd_EX_RT = 1'b0;
	end
endfunction
//Comparison function for port "Fwd_EX_RS"
function compare_Fwd_EX_RS;
input [1:0] UUT_output;
input [1:0] PATTERN;
	begin
		if (UUT_output !== PATTERN) compare_Fwd_EX_RS = 1'b1;
		else compare_Fwd_EX_RS = 1'b0;
	end
endfunction

// Unit Under Test port map
	ForwardingUnit UUT (
		.ID_Inst(ID_Inst),
		.ID_Branch(ID_Branch),
		.ID_JR(ID_JR),
		.EX_Inst(EX_Inst),
		.EX_JAL(EX_JAL),
		.WB_WriteReg(WB_WriteReg),
		.WB_RegWrite(WB_RegWrite),
		.MEM_WriteReg(MEM_WriteReg),
		.MEM_RegWrite(MEM_RegWrite),
		.Fwd_ID_RT(Fwd_ID_RT_actual),
		.Fwd_ID_RS(Fwd_ID_RS_actual),
		.Fwd_EX_RT(Fwd_EX_RT_actual),
		.Fwd_EX_RS(Fwd_EX_RS_actual));

initial
	begin
		report_file=$fopen("$DSN\\src\\Tests\\phase1b_report.log");
		errors_counter = 0;
		#SimulationTime;
		if (errors_counter)
		begin
			if(errors_counter < MAX_ERRORS) begin
				$display("Errors were encountered, differences are listed in phase1b_report.log");
				$fdisplay(report_file,"Some vectors failed.");
			end else begin
				$display("%d Errors were encountered, but only the first %d are listed in phase1b_report.log",errors_counter,MAX_ERRORS);
				$fdisplay(report_file,"%d Errors, %d reported. Some vectors failed.",errors_counter,MAX_ERRORS);
			end
		end
		else
		begin
			$display("All vectors passed.");
			$fdisplay(report_file,"All vectors passed.");
		end
		$fclose(report_file);
		$finish;
	end


initial
begin : STIMUL // begin of stimulus process
	#0
	ID_Inst = 10'bXXXXXXXXXX;
	ID_Branch = 1'bx;
	EX_Inst = 10'bXXXXXXXXXX;
	ID_JR = 1'bx;
	WB_WriteReg = 5'bXXXXX;
	WB_RegWrite = 1'bx;
	EX_JAL = 1'bx;
	MEM_RegWrite = 1'bx;
	Fwd_EX_RS = 2'bXX;
	Fwd_EX_RT = 2'bXX;
	Fwd_ID_RS = 1'bx;
	Fwd_ID_RT = 1'bx;
	MEM_WriteReg = 5'bXXXXX;
    #165000; //0
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	EX_JAL = 1'b0;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	Fwd_ID_RS = 1'b0;
	Fwd_ID_RT = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //165000
	ID_Inst = 10'b0000000001;
    #20000; //185000
	ID_Inst = 10'b0000101001;
	EX_Inst = 10'b0000000001;
	MEM_RegWrite = 1'b1;
    #20000; //205000
	ID_Inst = 10'b0000000001;
	EX_Inst = 10'b0000101001;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b10;
	MEM_WriteReg = 5'b00001;
    #20000; //225000
	ID_Inst = 10'b0000101010;
	EX_Inst = 10'b0000000001;
	WB_WriteReg = 5'b00001;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b01001;
    #20000; //245000
	ID_Inst = 10'b0000000001;
	EX_Inst = 10'b0000101010;
	WB_WriteReg = 5'b01001;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00001;
    #20000; //265000
	ID_Inst = 10'b0000101011;
	EX_Inst = 10'b0000000001;
	WB_WriteReg = 5'b00001;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b01010;
    #20000; //285000
	ID_Inst = 10'b0000000001;
	EX_Inst = 10'b0000101011;
	WB_WriteReg = 5'b01010;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00001;
    #20000; //305000
	ID_Inst = 10'b0000101101;
	EX_Inst = 10'b0000000001;
	WB_WriteReg = 5'b00001;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b01011;
    #20000; //325000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b0000101101;
	WB_WriteReg = 5'b01011;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00001;
    #20000; //345000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00001;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b01101;
    #20000; //365000
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b01101;
	MEM_WriteReg = 5'b11101;
    #20000; //385000
	ID_Inst = 10'b0001000000;
	ID_Branch = 1'b1;
	WB_WriteReg = 5'b11101;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b00010;
    #20000; //405000
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001000000;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //425000
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //445000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b1;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RT = 1'b1;
	MEM_WriteReg = 5'b00011;
    #20000; //465000
	ID_Inst = 10'b0000011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000011;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b11;
	Fwd_ID_RT = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //485000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //505000
	ID_Inst = 10'b0001000000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b00010;
    #20000; //525000
	ID_Inst = 10'b0000011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001000000;
	WB_WriteReg = 5'b00010;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //545000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //565000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RT = 1'b1;
	MEM_WriteReg = 5'b00011;
    #20000; //585000
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000011;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b11;
	Fwd_ID_RT = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //605000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //625000
	ID_Inst = 10'b0001100000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
    #20000; //645000
	ID_Inst = 10'b0000011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001100000;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //665000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //685000
	ID_Inst = 10'b0001100000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b00011;
    #20000; //705000
	ID_Inst = 10'b0000011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001100000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //725000
	ID_Inst = 10'b0000000100;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //745000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000000100;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00100;
    #20000; //765000
	ID_Inst = 10'b0010000000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b00;
	Fwd_ID_RS = 1'b1;
    #20000; //785000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0010000000;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //805000
	EX_Inst = 10'b0000000011;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //825000
	ID_Inst = 10'b0000000000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00011;
    #20000; //845000
	ID_Inst = 10'b0001100000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b00;
	Fwd_ID_RS = 1'b1;
    #20000; //865000
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001100000;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //885000
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //905000
	ID_Inst = 10'b0001100000;
	ID_Branch = 1'b1;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b00011;
    #20000; //925000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001100000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //945000
	EX_Inst = 10'b0000000011;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //965000
	ID_Inst = 10'b0000000000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00011;
    #20000; //985000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b00;
	Fwd_ID_RT = 1'b1;
    #20000; //1005000
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000011;
	Fwd_EX_RT = 2'b11;
	Fwd_ID_RT = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1025000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //1045000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1065000
	ID_Inst = 10'b0001100000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
    #20000; //1085000
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0001100000;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1105000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //1125000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0000011101;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00011;
    #20000; //1145000
	ID_Inst = 10'b0000000011;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_ID_RT = 1'b1;
    #20000; //1165000
	ID_Inst = 10'b0101101100;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000011;
	Fwd_EX_RT = 2'b11;
	Fwd_ID_RT = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1185000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0101101100;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //1205000
	ID_Inst = 10'b0110000000;
	EX_Inst = 10'b0000000000;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b01100;
    #20000; //1225000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0110000000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b01100;
	WB_RegWrite = 1'b1;
	EX_JAL = 1'b1;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1245000
	ID_Inst = 10'b1111100000;
	EX_Inst = 10'b0000000000;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b00000;
	EX_JAL = 1'b0;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	Fwd_ID_RS = 1'b1;
	MEM_WriteReg = 5'b11111;
    #20000; //1265000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b1111100000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b11111;
	Fwd_EX_RS = 2'b11;
	Fwd_ID_RS = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1285000
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
    #20000; //1305000
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1325000
	ID_Inst = 10'b0011100111;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
    #20000; //1345000
	ID_Inst = 10'b1110100000;
	EX_Inst = 10'b0011100111;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1365000
	ID_Inst = 10'b0000000010;
	EX_Inst = 10'b1110100000;
	WB_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00111;
    #20000; //1385000
	ID_Inst = 10'b0011100000;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00111;
	MEM_WriteReg = 5'b00000;
    #20000; //1405000
	ID_Inst = 10'b1110100000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0011100000;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //1425000
	EX_Inst = 10'b1110100000;
	WB_WriteReg = 5'b00010;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //1445000
	ID_Inst = 10'b0000000111;
	ID_Branch = 1'b1;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //1465000
	ID_Inst = 10'b0001011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0000000111;
	WB_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00100;
    #20000; //1485000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0001011101;
	WB_WriteReg = 5'b00100;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00111;
    #20000; //1505000
	ID_Inst = 10'b0010011101;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00111;
	WB_RegWrite = 1'b0;
	MEM_WriteReg = 5'b11101;
    #20000; //1525000
	ID_Inst = 10'b0001011101;
	ID_Branch = 1'b0;
	EX_Inst = 10'b0010011101;
	WB_WriteReg = 5'b11101;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
    #20000; //1545000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0001011101;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b11101;
    #20000; //1565000
	ID_Inst = 10'b1110100100;
	ID_Branch = 1'b1;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b11101;
	WB_RegWrite = 1'b0;
    #20000; //1585000
	ID_Inst = 10'b0000000000;
	ID_Branch = 1'b0;
	EX_Inst = 10'b1110100100;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
    #20000; //1605000
	ID_Inst = 10'b0001000000;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00100;
    #20000; //1625000
	ID_Inst = 10'b0000000010;
	EX_Inst = 10'b0001000000;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
    #20000; //1645000
	ID_Inst = 10'b0001000011;
	EX_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00100;
    #20000; //1665000
	ID_Inst = 10'b0001000100;
	EX_Inst = 10'b0001000011;
	WB_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //1685000
	ID_Inst = 10'b0000000010;
	EX_Inst = 10'b0001000100;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	MEM_WriteReg = 5'b00011;
    #20000; //1705000
	ID_Inst = 10'b0001011101;
	EX_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b00100;
    #20000; //1725000
	EX_Inst = 10'b0001011101;
	WB_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //1745000
	ID_Inst = 10'b0000000010;
	WB_WriteReg = 5'b00010;
    #20000; //1765000
	ID_Inst = 10'b0001000010;
	EX_Inst = 10'b0000000010;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00011;
    #20000; //1785000
	ID_Inst = 10'b0001000011;
	EX_Inst = 10'b0001000010;
	WB_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //1805000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b0001000011;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RT = 2'b00;
    #20000; //1825000
	ID_Inst = 10'b0000000101;
	EX_Inst = 10'b0000000000;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //1845000
	EX_Inst = 10'b0000000101;
	WB_WriteReg = 5'b00011;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00101;
    #20000; //1865000
	WB_WriteReg = 5'b00101;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00110;
    #20000; //1885000
	ID_Inst = 10'b1110100101;
	WB_WriteReg = 5'b00110;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00111;
    #20000; //1905000
	EX_Inst = 10'b1110100101;
	WB_WriteReg = 5'b00111;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00101;
    #20000; //1925000
	ID_Inst = 10'b0000000101;
	WB_WriteReg = 5'b00101;
    #20000; //1945000
	ID_Inst = 10'b1110100101;
	EX_Inst = 10'b0000000101;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00110;
    #20000; //1965000
	EX_Inst = 10'b1110100101;
	WB_WriteReg = 5'b00110;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00101;
    #20000; //1985000
	ID_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00101;
    #20000; //2005000
	ID_Inst = 10'b0001011101;
	EX_Inst = 10'b1110111101;
	Fwd_EX_RT = 2'b00;
    #20000; //2025000
	ID_Inst = 10'b0001000011;
	EX_Inst = 10'b0001011101;
	Fwd_EX_RS = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //2045000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b0001000011;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b11;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00011;
    #20000; //2065000
	ID_Inst = 10'b1110100010;
	EX_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00100;
    #20000; //2085000
	ID_Inst = 10'b0001100010;
	EX_Inst = 10'b1110100010;
	WB_WriteReg = 5'b00100;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //2105000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b0001100010;
	WB_WriteReg = 5'b00010;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00011;
    #20000; //2125000
	ID_Inst = 10'b0001000010;
	EX_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00011;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00100;
    #20000; //2145000
	EX_Inst = 10'b0001000010;
	WB_WriteReg = 5'b00100;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //2165000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00010;
    #20000; //2185000
	ID_Inst = 10'b1111111101;
	EX_Inst = 10'b0000000000;
	EX_JAL = 1'b1;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
	MEM_WriteReg = 5'b00011;
    #20000; //2205000
	ID_Inst = 10'b0010111111;
	EX_Inst = 10'b1111111101;
	WB_WriteReg = 5'b00011;
	EX_JAL = 1'b0;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b11111;
    #20000; //2225000
	ID_Inst = 10'b1111100000;
	EX_Inst = 10'b0010111111;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b11111;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00101;
    #20000; //2245000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b1111100000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00101;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00110;
    #20000; //2265000
	ID_Inst = 10'b0100100000;
	EX_Inst = 10'b0000000000;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b00110;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //2285000
	ID_Inst = 10'b1111111101;
	EX_Inst = 10'b0100100000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	EX_JAL = 1'b1;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
    #20000; //2305000
	ID_Inst = 10'b0010111111;
	EX_Inst = 10'b1111111101;
	WB_RegWrite = 1'b1;
	EX_JAL = 1'b0;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b11111;
    #20000; //2325000
	ID_Inst = 10'b1111100000;
	EX_Inst = 10'b0010111111;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b11111;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00101;
    #20000; //2345000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b1111100000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00101;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00110;
    #20000; //2365000
	ID_Inst = 10'b0101000000;
	EX_Inst = 10'b0000000000;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b00110;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //2385000
	ID_Inst = 10'b1111011101;
	EX_Inst = 10'b0101000000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	EX_JAL = 1'b1;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b01;
	Fwd_EX_RT = 2'b01;
    #20000; //2405000
	ID_Inst = 10'b0010111110;
	EX_Inst = 10'b1111011101;
	WB_RegWrite = 1'b1;
	EX_JAL = 1'b0;
	Fwd_EX_RS = 2'b10;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b11110;
    #20000; //2425000
	ID_Inst = 10'b1111000000;
	EX_Inst = 10'b0010111110;
	ID_JR = 1'b1;
	WB_WriteReg = 5'b11110;
	Fwd_EX_RT = 2'b11;
	MEM_WriteReg = 5'b00101;
    #20000; //2445000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b1111000000;
	ID_JR = 1'b0;
	WB_WriteReg = 5'b00101;
	Fwd_EX_RS = 2'b00;
	Fwd_EX_RT = 2'b00;
	MEM_WriteReg = 5'b00110;
    #20000; //2465000
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00110;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00000;
    #20000; //2485000
	WB_WriteReg = 5'b00000;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //2505000
	ID_Inst = 10'b1110111101;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
    #20000; //2525000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b1110111101;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
    #20000; //2545000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b0000011101;
	WB_RegWrite = 1'b1;
    #20000; //2565000
	ID_Inst = 10'b0000000000;
	EX_Inst = 10'b1110111101;
	MEM_WriteReg = 5'b00010;
    #20000; //2585000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b0000000000;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
    #20000; //2605000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
    #20000; //2625000
	ID_Inst = 10'b1110100000;
	EX_Inst = 10'b1110111101;
	MEM_WriteReg = 5'b00010;
    #20000; //2645000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b1110100000;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
    #20000; //2665000
	ID_Inst = 10'b0000001011;
	EX_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b00010;
    #20000; //2685000
	ID_Inst = 10'b0000011101;
	EX_Inst = 10'b0000001011;
	WB_WriteReg = 5'b00010;
	MEM_WriteReg = 5'b00000;
    #20000; //2705000
	ID_Inst = 10'b0101100011;
	EX_Inst = 10'b0000011101;
	WB_WriteReg = 5'b00000;
	MEM_WriteReg = 5'b01011;
    #20000; //2725000
	ID_Inst = 10'b0001100000;
	EX_Inst = 10'b0101100011;
	WB_WriteReg = 5'b01011;
	Fwd_EX_RS = 2'b11;
	MEM_WriteReg = 5'b00010;
    #20000; //2745000
	EX_Inst = 10'b0001100000;
	WB_WriteReg = 5'b00010;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //2765000
	ID_Inst = 10'b0101100011;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00100;
    #20000; //2785000
	ID_Inst = 10'b0000000011;
	EX_Inst = 10'b0101100011;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b1;
    #20000; //2805000
	EX_Inst = 10'b0000000011;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b00011;
    #20000; //2825000
	ID_Inst = 10'b0000001011;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00100;
    #20000; //2845000
	ID_Inst = 10'b0110000010;
	EX_Inst = 10'b0000001011;
	WB_WriteReg = 5'b00100;
	WB_RegWrite = 1'b1;
    #20000; //2865000
	ID_Inst = 10'b0110000000;
	EX_Inst = 10'b0110000010;
	Fwd_EX_RS = 2'b10;
	MEM_WriteReg = 5'b01100;
    #20000; //2885000
	ID_Inst = 10'b1110111101;
	EX_Inst = 10'b0110000000;
	WB_WriteReg = 5'b01100;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b11;
	MEM_WriteReg = 5'b00010;
    #20000; //2905000
	ID_Inst = 10'b0101100010;
	EX_Inst = 10'b1110111101;
	WB_WriteReg = 5'b00010;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //2925000
	ID_Inst = 10'b0001000000;
	EX_Inst = 10'b0101100010;
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	Fwd_EX_RT = 2'b10;
	MEM_WriteReg = 5'b00010;
    #20000; //2945000
	ID_Inst = 10'b0101101011;
	EX_Inst = 10'b0001000000;
	WB_WriteReg = 5'b00010;
	MEM_RegWrite = 1'b0;
	Fwd_EX_RS = 2'b11;
	Fwd_EX_RT = 2'b00;
    #20000; //2965000
	EX_Inst = 10'b0101101011;
	WB_RegWrite = 1'b0;
	MEM_RegWrite = 1'b1;
	Fwd_EX_RS = 2'b00;
	MEM_WriteReg = 5'b00011;
    #20000; //2985000
	WB_WriteReg = 5'b00011;
	WB_RegWrite = 1'b1;
	MEM_RegWrite = 1'b0;
	MEM_WriteReg = 5'b01011;
    #20000; //3005000
	ID_Inst = 10'b0000000000;
	WB_WriteReg = 5'b01011;
	WB_RegWrite = 1'b0;
    #20000; //3025000
	EX_Inst = 10'b0000000000;
	MEM_RegWrite = 1'b1;
	MEM_WriteReg = 5'b01100;
    #20000; //3045000
	WB_WriteReg = 5'b01100;
	WB_RegWrite = 1'b1;
	MEM_WriteReg = 5'b00000;
    #20000; //3065000
	WB_WriteReg = 5'b00000;
    #19000; //3085000
end // end of stimulus process
	



//Set of always bloks for ports monitoring.
//One block per output port.
//Always block for monitoring port "Fwd_ID_RT";
always @(Fwd_ID_RT or Fwd_ID_RT_actual)
	begin
		#Fwd_ID_RT_WaitTime
		if (compare_Fwd_ID_RT(Fwd_ID_RT,Fwd_ID_RT_actual))
		begin
			errors_counter = errors_counter + 1;
			if(errors_counter < MAX_ERRORS) begin
				$fdisplay(report_file,$realtime,,"ps; Port Fwd_ID_RT: Expected value is %b, Actual value is %b",Fwd_ID_RT,Fwd_ID_RT_actual);
				$display($realtime,,"ps; Error on port Fwd_ID_RT: Expected value is %b, Actual value is %b",Fwd_ID_RT,Fwd_ID_RT_actual);
			end
		end
	end
//Always block for monitoring port "Fwd_ID_RS";
always @(Fwd_ID_RS or Fwd_ID_RS_actual)
	begin
		#Fwd_ID_RS_WaitTime
		if (compare_Fwd_ID_RS(Fwd_ID_RS,Fwd_ID_RS_actual))
		begin
			errors_counter = errors_counter + 1;
			if(errors_counter < MAX_ERRORS) begin
				$fdisplay(report_file,$realtime,,"ps; Port Fwd_ID_RS: Expected value is %b, Actual value is %b",Fwd_ID_RS,Fwd_ID_RS_actual);
				$display($realtime,,"ps; Error on port Fwd_ID_RS: Expected value is %b, Actual value is %b",Fwd_ID_RS,Fwd_ID_RS_actual);
			end
		end
	end
//Always block for monitoring port "Fwd_EX_RT";
always @(Fwd_EX_RT or Fwd_EX_RT_actual)
	begin
		#Fwd_EX_RT_WaitTime
		if (compare_Fwd_EX_RT(Fwd_EX_RT,Fwd_EX_RT_actual))
		begin
			errors_counter = errors_counter + 1;
			if(errors_counter < MAX_ERRORS) begin
				$fdisplay(report_file,$realtime,,"ps; Port Fwd_EX_RT: Expected value is %b, Actual value is %b",Fwd_EX_RT,Fwd_EX_RT_actual);
				$display($realtime,,"ps; Error on port Fwd_EX_RT: Expected value is %b, Actual value is %b",Fwd_EX_RT,Fwd_EX_RT_actual);
			end
		end
	end
//Always block for monitoring port "Fwd_EX_RS";
always @(Fwd_EX_RS or Fwd_EX_RS_actual)
	begin
		#Fwd_EX_RS_WaitTime
		if (compare_Fwd_EX_RS(Fwd_EX_RS,Fwd_EX_RS_actual))
		begin
			errors_counter = errors_counter + 1;
			if(errors_counter < MAX_ERRORS) begin
				$fdisplay(report_file,$realtime,,"ps; Port Fwd_EX_RS: Expected value is %b, Actual value is %b",Fwd_EX_RS,Fwd_EX_RS_actual);
				$display($realtime,,"ps; Error on port Fwd_EX_RS: Expected value is %b, Actual value is %b",Fwd_EX_RS,Fwd_EX_RS_actual);
			end
		end
	end

endmodule
